var SlJsInfra = require("sl-js-infra").SlJsInfra;
var troubleshootingPage = "https://sealights.atlassian.net/wiki/spaces/SUP/pages/1172144129/Javascript+and+Node.js+Source+Map+Files";
function SourceFilesNotifier(logger) {
    this.MAX_FILES_NO_NOTIFY = 10;
    this.counter = 0;
    this.logger = logger;
}

SourceFilesNotifier.prototype.notifySources = function(sourcesArr, generatedFile, hasColumnInfo) {
    if(this.counter < this.MAX_FILES_NO_NOTIFY) {
        hasColumnInfo ? notifySourceWithColumn(sourcesArr, generatedFile) : warnSourceWithOutColumn(sourcesArr, generatedFile);
        this.counter ++;
    } else {
        this.logger.debug("Not sending sources for file '%s'. already sent sources for '%s files", generatedFile, this.MAX_FILES_NO_NOTIFY)
    }
}

function notifySourceWithColumn(sourcesArr, generatedFile){
    var message = JSON.stringify({
        generatedFileName: generatedFile,
        sources: sourcesArr
    });
    SlJsInfra.CockpitNotifier.sendGenericMessage(message);
}

function warnSourceWithOutColumn(sourcesArr, generatedFile) {
    var message = "Detected source-maps without column information, missing column information may result in inaccurate coverage. " +
        "For more information: " + troubleshootingPage +
        ". Generated file: " + generatedFile +
        ". Sources: " + sourcesArr;
    SlJsInfra.CockpitNotifier.sendWarning(message)
}
module.exports = SourceFilesNotifier;
